// This may look like C code, but it is really -*- C++ -*-

/**********************************************************************
    Author:    Bill Roth(387-820-7277)
    Date:      Wed Dec 16 20:16:29 1992 @ feline
    File:      /var/home/roth/code/iv/if/MainWindow.h
    Comments:      File Name: The definition of the MainWindow Class
**********************************************************************/


#ifndef MainWindow_h
#define MainWindow_h

#include "MainWindow-core.h"
#include <stdio.h>

typedef enum {
  consult,reconsult
} LoadType;

class ModuleWindow;
class UArray;

class MainWindow : public MainWindow_core {
public:
  MainWindow(const char*);
  
  virtual void _About___();
  virtual void _LoadNewFile___();
  virtual void _LoadModuleDump___();
  virtual void _Quit();
  virtual void _Consult();
  virtual void _ReConsult();
  virtual void _ShowSelectedModules___();
  virtual void _RemoveSelectedModules();
  virtual void _ClearAllModules();
  virtual void modulesSelected();
  virtual void windowIsClosing(ModuleWindow *m);
  virtual void Handle(Event& e);
  virtual void setFiles(char* filename); // files to load after startup
private:
  void doMessage(const char* s, const char* t);
  void loadModuleFiles(LoadType& t);
  int fileCheck(const char *path,boolean& isDir);
  boolean isCoralFile(const char*file);
  void garbageCollect();
  void ShowDump(int i);		// brings up to the moduleWIndow.
  void loadDirectory(char* dir);

  UArray *gclist;		// list of things to gc
  int numModules;
  
};

#endif


