/************************************************************************
 ========================================================================
 CORAL 
 (c)  Copyright R. Ramakrishnan and The CORAL Group, 
 University of Wisconsin at Madison.
 (1992) All Rights Reserved.
 Version 0.1
 ========================================================================



 ------------------------------------------------------------------------
 CORAL Version 0.1
 RESEARCH SOFTWARE DISCLAIMER -------------------------------------------
 ------------------------------------------------------------------------

    As unestablished, research software, this program is provided free of 
    charge on an "as is" basis without warranty of any kind, either 
    express or implied.  Acceptance and use of this program constitutes 
    the user's understanding that (s)he will have no recourse for any 
    actual or consequential damages, including, but not limited to, 
    lost profits or savings, arising out of the use of or inability to 
    use this program.  

 ------------------------------------------------------------------------
 USER AGREEMENT ---------------------------------------------------------
 ------------------------------------------------------------------------

     BY ACCEPTANCE AND USE OF THIS EXPERIMENTAL PROGRAM
     THE USER AGREES TO THE FOLLOWING:

     a.  This program is provided free of charge for the user's personal, 
	 non-commercial, experimental use.

     b.  All title, ownership and rights to this program and any copies 
         remain with the copyright holder, irrespective of the ownership 
	 of the media on which the program resides.

     c.  The user is permitted to create derivative works to this program.  
         However, all copies of the program and its derivative works must
         contain the CORAL copyright notice, the UNESTABLISHED SOFTWARE 
         DISCLAIMER and this USER AGREEMENT.

     d.  The user understands and agrees that this program and any 
         derivative works are to be used solely for experimental purposes 
	 and are not to be sold or commercially exploited in any manner 
	 WITHOUT EXPRESS WRITTEN PERMISSION.

     e.  We request that the user supply us with a copy of any changes, 
         enhancements, or derivative works which the user may create,
	 with the user's permission to redistribute it.
	 Copies of such material should be sent to:  CORAL@CS.WISC.EDU

-------------------------------------------------------------------------
*************************************************************************/


#include <stdio.h>
#include <string.h>
#include "mystrings.h"

extern void fatal_error(char *);

mystring::mystring()
{
  max = 256;
   pos = 0;
   buf = new (char[max]);
   if (buf == NULL)
     fatal_error ("new failed in mystring constructor\n");
   buf[0] = '\0';
 }

void mystring::append(char *str) {
  if (str == NULL)
    return;
  int len = strlen(str);
  if ((pos + len) >= max) {
    char *new_buf = new (char [max * 2]);
    if (new_buf == NULL)
      fatal_error ("new failed in mystring append\n");
    strncpy (new_buf, buf, pos+1);
    delete(buf);
    buf = new_buf;
    max *= 2;
  }
  strncpy(buf+pos, str, len);
  pos += len;
  buf[pos] = '\0';
}

void mystring::print(FILE *output_file)
{  
  if (output_file)
    fprintf(output_file, "%s", buf);
  else 
    fprintf(stderr, "something fishy in mystring print fn\n");
}


mystring::~mystring() {
   
   delete(buf);
   
 }
