/************************************************************************
 ========================================================================
 CORAL 
 (c)  Copyright R. Ramakrishnan and The CORAL Group, 
 University of Wisconsin at Madison.
 (1992) All Rights Reserved.
 Version 0.1
 ========================================================================



 ------------------------------------------------------------------------
 CORAL Version 0.1
 RESEARCH SOFTWARE DISCLAIMER -------------------------------------------
 ------------------------------------------------------------------------

    As unestablished, research software, this program is provided free of 
    charge on an "as is" basis without warranty of any kind, either 
    express or implied.  Acceptance and use of this program constitutes 
    the user's understanding that (s)he will have no recourse for any 
    actual or consequential damages, including, but not limited to, 
    lost profits or savings, arising out of the use of or inability to 
    use this program.  

 ------------------------------------------------------------------------
 USER AGREEMENT ---------------------------------------------------------
 ------------------------------------------------------------------------

     BY ACCEPTANCE AND USE OF THIS EXPERIMENTAL PROGRAM
     THE USER AGREES TO THE FOLLOWING:

     a.  This program is provided free of charge for the user's personal, 
	 non-commercial, experimental use.

     b.  All title, ownership and rights to this program and any copies 
         remain with the copyright holder, irrespective of the ownership 
	 of the media on which the program resides.

     c.  The user is permitted to create derivative works to this program.  
         However, all copies of the program and its derivative works must
         contain the CORAL copyright notice, the UNESTABLISHED SOFTWARE 
         DISCLAIMER and this USER AGREEMENT.

     d.  The user understands and agrees that this program and any 
         derivative works are to be used solely for experimental purposes 
	 and are not to be sold or commercially exploited in any manner 
	 WITHOUT EXPRESS WRITTEN PERMISSION.

     e.  We request that the user supply us with a copy of any changes, 
         enhancements, or derivative works which the user may create,
	 with the user's permission to redistribute it.
	 Copies of such material should be sent to:  CORAL@CS.WISC.EDU

-------------------------------------------------------------------------
*************************************************************************/

#ifndef CORAL_MAGIC_EXTERNS_H

#define CORAL_MAGIC_EXTERNS_H

#include "coral-includes.h"

extern void mark_basepreds(struct collection *);
extern void preprocess_for_grouping(struct collection *, struct collection *);
extern void supopt();
extern void supmagic(struct collection *, struct collection *);
extern void siporder(struct collection *);
extern void fullmagic(struct collection *, struct collection *);
extern void nomagic(struct collection *);
extern struct sip * findadsip(Clause * adrule, int p);
extern int adorn(struct collection *, struct collection *);

extern struct collection pre_ad_rules[1];
extern struct collection ad_rules[1];
extern struct collection magic_rules[1];

extern Literal *build_head_pred(struct rule *newrule, Literal *oldhead);
extern Literal *build_magic_pred(struct rule *newrule, Literal *oldhead,
		int use_share_opt, int argnum = 0) ;
extern void 	create_functor_literals(struct rule *magicrule);
extern int	count_bound_functor_args(Literal *head);
extern void	make_new_rule_vars(struct rule *magicrule, int num_new_vars);

#endif
